
// ==UserScript==
// @name         [免费查题]中国大学慕课MOOC获取[标准答案][他人非标准答案][OJ题][答案统计]
// @namespace    https://www.icourse163.click/
// @version      0.3
// @description  全网最全题库，测验作业考试标准答案保证100%，全网唯一支持查看他人答案与OJ编程题答案，网页代替脚本支持任意设备浏览100%安全避免检测，大数据统计全网答案分布
// @author       icourse163
// @match        *://www.icourse163.org/learn/*
// @match        *://www.icourse163.org/spoc/learn/*
// @grant        none
// ==/UserScript==
(function() {
    "use strict";
    justice();

    function justice() {
        var websiteAnswer = window.location.href.match(new RegExp("(https|http)://www.icourse163.org/(spoc/|)learn/.+"));
        if (websiteAnswer == null) {
            alert("请进入某个科目的MOOC页面后再使用此脚本!\n如:\nhttps://www.icourse163.org/learn/...\nhttps://www.icourse163.org/spoc/learn/...");
            return
        }
        var websiteNow = websiteAnswer[0];
        if (websiteNow.match(new RegExp("https://.+")) == null) {
            websiteNow = websiteNow.replace(new RegExp("http:", "g"), "https:");
            window.location.href = websiteNow
        }
        exec()
    }

    function exec() {
        var RANDOM_ID_FIRST_DICT = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ".split("");
        var RANDOM_ID_OTHER_DICT = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789-_".split("");
        var iframeInf = {
            isPack: false,
            width: 255,
            height: 300,
            packText: "点击收起",
            unPackText: "ㅤ",
        };
        run();

        function run() {
            let mooc_helper_window = generateRandomString();
            let mooc_helper_pack_up_btn = generateRandomString();
            let mooc_helper_content = generateRandomString();
            let mooc_helper_engineDataBtn = generateRandomString();
            let mooc_helper_data = generateRandomString();
            var divTop = window.innerHeight * 0.1;
            var divLeft = window.innerWidth * 0.7;
            let topDiv = document.getElementsByClassName("m-learnhead")[0];
            let numberInstruction = '<table border="1"><tr><th>编码类型</th><th>含义</th></tr><tr><td>题库号</td><td>可获取某个试卷中题库的所有题目答案</td></tr><tr><td>试卷号</td><td>当前答题时呈现出的试卷编码</td></tr><tr><td>所有题目</td><td>当前答题时所有题目组成的列表编号</td></tr><tr><td>第i题</td><td>某个题目的题目号</td></tr></table>';
            topDiv.innerHTML += `<div style="position:fixed; z-index:999; top:${divTop}px; left:${divLeft}px; border:1; width:${iframeInf.width}px; height:${iframeInf.height}px; background-color: rgba(221,221,221,0.5);"id="${mooc_helper_window}">` + `<div style="height:25px">` + `<a style="font-size: 17px;color:#212121;"id="${mooc_helper_pack_up_btn}">${iframeInf.packText}</a>` + `<br><div id=${mooc_helper_content}>` + `<div style="padding:8px 0px 0px 0px; font-size: 13px;"><a style="color:#03a9f4;"target="_blank"href="https://www.icourse163.click">点我前往搜题平台www.icourse163.click</a></div>` + "推荐添加到收藏夹" + `<br><br><a style="color:#00c758; "id=${mooc_helper_engineDataBtn}>加载试卷信息</a>` + `<div style="overflow:auto;height:110px;"id=${mooc_helper_data}></div>` + `${numberInstruction}` + `</div>` + "</div></div>";
            document.getElementById(mooc_helper_pack_up_btn).onclick = function() {
                if (iframeInf.isPack) {
                    iframeInf.isPack = false;
                    document.getElementById(mooc_helper_pack_up_btn).innerHTML = iframeInf.packText;
                    document.getElementById(mooc_helper_window).style.width = iframeInf.width + "px";
                    document.getElementById(mooc_helper_window).style.height = iframeInf.height + "px";
                    document.getElementById(mooc_helper_content).style.display = "inline"
                } else {
                    iframeInf.isPack = true;
                    document.getElementById(mooc_helper_pack_up_btn).innerHTML = iframeInf.unPackText;
                    document.getElementById(mooc_helper_window).style.width = 20 + "px";
                    document.getElementById(mooc_helper_window).style.height = 20 + "px";
                    document.getElementById(mooc_helper_content).style.display = "none"
                }
            };
            document.getElementById(mooc_helper_engineDataBtn).onclick = function() {
                document.getElementById(mooc_helper_data).innerHTML = "";
                setTimeout(function() {
                    let data = "";
                    let paperStateObj = getPaperTypeAndId();
                    data += `题库号`;
                    if (paperStateObj.paperId != null) {
                        data += `${paperStateObj.paperId}`
                    }
                    data += "<br>试卷号 ";
                    let aid = null;
                    if (paperStateObj.paperId != null && paperStateObj.paperType != null) {
                        aid = getPaperAidDetail(paperStateObj);
                        if (aid != null) {
                            data += `${encryptId([aid+""])}`
                        }
                    }
                    document.getElementById(mooc_helper_data).innerHTML = data;
                    if (aid != null) {
                        getQids(paperStateObj.paperId, aid, mooc_helper_data)
                    }
                }, 100)
            }
        }

        function getPaperTypeAndId() {
            var id = null;
            let method = null;
            var isExam = false;
            let ids = null;
            let isQuiz = true;
            if ((ids = parent.location.href.match(/ojhw\?id=(.*)/))) {
                id = ids[1];
                method = "OJ";
                isQuiz = false
            } else if ((ids = parent.location.href.match(/hw\?id=(.*)/))) {
                id = ids[1];
                method = "getHomeworkInfo";
                isQuiz = false
            } else if ((ids = parent.location.href.match(/quiz\?id=(.*)/))) {
                id = ids[1];
                method = "getQuizInfo";
                isQuiz = true
            } else if ((ids = parent.location.href.match(/quizscore\?id=(.*)&/))) {
                id = ids[1];
                method = "getQuizInfo";
                isQuiz = true
            } else if ((ids = parent.location.href.match(/eid=(.*)\&id=(.*)/))) {
                id = ids[2];
                method = "getHomeworkInfo";
                isExam = true
            }
            return {
                paperType: method,
                paperId: id,
                isExam: isExam,
                isQuiz: isQuiz,
            }
        }

        function getPaperAidDetail(paperObj) {
            var aid = "";
            if (parent.location.href.match(/quizscore\?id=(.*)&/)) {
                aid = window.location.href.match(/aid=(.*)/)[1]
            } else {
                if (paperObj.isExam) {
                    aid = getPaperAid(paperObj.paperId, "getQuizInfo");
                    if (aid == null) {
                        aid = getPaperAid(paperObj.paperId, "getHomeworkInfo");
                        if (aid == null) {
                            aid = getOjAid(paperObj.paperId)
                        }
                    }
                } else {
                    if (paperObj.paperType == "OJ") {
                        aid = getOjAid(paperObj.paperId)
                    } else {
                        aid = getPaperAid(paperObj.paperId, paperObj.paperType)
                    }
                }
            } if (aid == null) {
                return
            }
            if (aid == "0" || aid == "1" || aid == "-1") {
                aid = null
            }
            return aid
        }

        function getPaperAid(paperId, paperType) {
            var aid = null;
            post("https://www.icourse163.org/dwr/call/plaincall/MocQuizBean." + paperType + ".dwr", false, "callCount=1&scriptSessionId=${scriptSessionId}190&c0-scriptName=MocQuizBean" + `&c0-methodName=${paperType}` + "&c0-id=0" + `&c0-param0=string:${paperId}` + "&c0-param1=null:null&c0-param2=boolean:false&batchId=1", function(responseText) {
                var aids = responseText.match(/{aid:(.*?),/);
                if (aids == null) {
                    return null
                }
                aid = aids[1]
            });
            return aid
        }

        function getOjAid(paperId) {
            var aid = null;
            post("https://www.icourse163.org/dwr/call/plaincall/YocOJQuizBean.getOJPaperInfo.dwr", false, "callCount=1&scriptSessionId=${scriptSessionId}190&c0-scriptName=YocOJQuizBean&c0-methodName=getOJPaperInfo&c0-id=0" + `&c0-param0=string:${paperId}` + "&c0-param1=null:null&c0-param2=boolean:false&batchId=1", function(responseText) {
                var aids = responseText.match(/{aid:(.*?),/);
                if (aids == null) {
                    return null
                }
                aid = aids[1]
            });
            return aid
        }

        function getQids(tid, aid, mooc_helper_data) {
            post("https://www.icourse163.org/dwr/call/plaincall/MocQuizBean.getHomeworkPaperDto.dwr", false, "callCount=1&scriptSessionId=${scriptSessionId}190&" + `c0-scriptName=MocQuizBean&c0-methodName=getHomeworkPaperDto&c0-id=1&c0-param0=number:${tid}&c0-param1=null:null&c0-param2=boolean:true&c0-param3=number:1&c0-param4=number:${aid}&batchId=1`, function(responseText) {
                if (responseText.match(/dwr.engine._remoteHandleException/)) {
                    document.getElementById(mooc_helper_data).innerHTML += '<br><span style="color:red;">题目加载失败，请过几秒再重新点击加载</span>';
                    return
                }
                responseText = responseText.replace(new RegExp("dwr.engine._remoteHandleCallback", "g"), "aaa");
                eval(responseText);

                function aaa(a, b, obj) {
                    let arr = [];
                    if (obj != null) {
                        if (obj.objectiveQList != null) {
                            for (var i = 0; i < obj.objectiveQList.length; i++) {
                                let ele = obj.objectiveQList[i];
                                arr.push(ele.id)
                            }
                        }
                        if (obj.subjectiveQList != null) {
                            for (var i = 0; i < obj.subjectiveQList.length; i++) {
                                let ele = obj.subjectiveQList[i];
                                arr.push(ele.id)
                            }
                        }
                    }
                    let text = "";
                    let qidsAll = encryptId(arr);
                    text += `<br>所有题目${qidsAll}`;
                    for (var i = 0; i < arr.length; i++) {
                        let ele = arr[i];
                        text += `<br>第${i+1}题${encryptId([ele])}`
                    }
                    if (arr.length > 0) {
                        document.getElementById(mooc_helper_data).innerHTML += text
                    }
                }
            })
        }

        function encryptId(ids) {
            let mahs = ["a", "b", "c", "d", "e", "f", "g", "h", "i", "k"];
            let key = Math.floor(Math.random() * 100) + 1;
            let keyb = textToArrayBuffer(key);
            let keys = "";
            let cod = "";
            for (var i = 0; i < keyb.length; i++) {
                let temp = keyb[i];
                keys += mahs[Math.floor(temp / 10)];
                keys += mahs[temp % 10]
            }
            cod += keys;
            cod += "m";
            for (var i = 0; i < ids.length; i++) {
                let temp = "";
                let l = ids[i];
                l = l * key + 3;
                let f = textToArrayBuffer(l);
                for (var j = 0; j < f.length; j++) {
                    temp += mahs[f[j] - 48]
                }
                cod += temp;
                cod += "y"
            }
            ids = cod;

            function textToArrayBuffer(s) {
                s += "";
                var i = s.length;
                var n = 0;
                var ba = new Array();
                for (var j = 0; j < i;) {
                    var c = s.codePointAt(j);
                    if (c < 128) {
                        ba[n++] = c;
                        j++
                    } else if (c > 127 && c < 2048) {
                        ba[n++] = (c >> 6) | 192;
                        ba[n++] = (c & 63) | 128;
                        j++
                    } else if (c > 2047 && c < 65536) {
                        ba[n++] = (c >> 12) | 224;
                        ba[n++] = ((c >> 6) & 63) | 128;
                        ba[n++] = (c & 63) | 128;
                        j++
                    } else {
                        ba[n++] = (c >> 18) | 240;
                        ba[n++] = ((c >> 12) & 63) | 128;
                        ba[n++] = ((c >> 6) & 63) | 128;
                        ba[n++] = (c & 63) | 128;
                        j += 2
                    }
                }
                let arrayBuffer = new Uint8Array(ba).buffer;
                return Array.prototype.slice.call(new Uint8Array(arrayBuffer))
            }
            return ids
        }

        function generateRandomString() {
            let name = RANDOM_ID_FIRST_DICT[Math.floor(Math.random() * RANDOM_ID_FIRST_DICT.length)];
            let otherLength = RANDOM_ID_OTHER_DICT.length;
            for (var i = 0; i < 31; i++) {
                name += RANDOM_ID_OTHER_DICT[Math.floor(Math.random() * otherLength)]
            }
            return name
        }

        function post(url, async, data, successHandle) {
            var xhr;
            if (window.XMLHttpRequest) {
                xhr = new XMLHttpRequest()
            } else {
                xhr = new ActiveXObject("Microsoft.XMLHTTP")
            }
            xhr.open("POST", url, async);
            xhr.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
            xhr.onreadystatechange = function() {
                if (xhr.readyState == 4) {
                    if (xhr.status == 200 || xhr.status == 304) {
                        successHandle(xhr.responseText)
                    }
                }
            };
            xhr.send(data)
        }
    }
})();
